import java.net.*;
import java.io.*;

public class AdminCommunicator
{
  private String adminHost;
  private int adminPort;
  private Socket adminSocket;
  private DataOutputStream out;
  private BufferedReader in;

  public AdminCommunicator(String host, int port)
  {
    adminHost=new String(host);
    adminPort=port;
  }//Fine costruttore
  
  public String getConfigParams()
  {
    try
    {
      //si crea il socket verso il proxy
      adminSocket=new Socket(adminHost,adminPort);
      out=new DataOutputStream(adminSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(adminSocket.getInputStream()));
      out.writeBytes("ADMIN\n");
      out.flush();
      String configParams=in.readLine();
      return (configParams);
    }
    catch(IOException e)
    {
      try
      {
        out.close();
        in.close();
        adminSocket.close();
      }
      catch (Exception e2)
      {}
      System.out.println("Errore nel contattare l'AdminServer "+e.toString());
      return "ERRORE";
    }
  }//Fine getConfigParams
  
  public String sendConfigParams(String configString)
  {
    if (!configString.equals("NULL"))
    {
      try
      {
        out.writeBytes("OK\n");
        out.writeBytes(configString);
        out.flush();
        out.close();
        in.close();
        adminSocket.close();
        return "OK";
      }
      catch(IOException ioe)
      {
        return "ERRORE";
      }
    }
    else
    {
      try
      {
        out.writeBytes("CANCEL\n");
        out.flush();
        out.close();
        in.close();
        adminSocket.close();
        return "OK";
      }
      catch(IOException ioe)
      {
        return "ERRORE";
      }
    }
  }//Fine sendConfigParams

}//Fine classe AdminCommunicator