/*
  A basic extension of the java.awt.Dialog class
 */
import java.awt.*;

public class DelHostDialog extends Dialog
{
  Admin applParent;
  int hostIndex;
  
  public DelHostDialog(Frame parent, boolean modal)
  {
    super(parent, modal);
    //{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(400,300);
		label1 = new java.awt.Label(" un'operazione irreversibile.",Label.CENTER);
		label1.setBounds(95,108,210,26);
		add(label1);
		label2 = new java.awt.Label("Sicuro di voler continuare?",Label.CENTER);
		label2.setBounds(95,144,210,26);
		add(label2);
		okButton = new java.awt.Button();
		okButton.setLabel("OK");
		okButton.setBounds(129,204,45,25);
		okButton.setBackground(new Color(12632256));
		add(okButton);
		cancelButton = new java.awt.Button();
		cancelButton.setLabel("Cancel");
		cancelButton.setBounds(225,204,45,25);
		cancelButton.setBackground(new Color(12632256));
		add(cancelButton);
		label3 = new java.awt.Label("ATTENZIONE!",Label.CENTER);
		label3.setBounds(95,36,210,26);
		add(label3);
		label4 = new java.awt.Label("L'eliminazione del sito ",Label.CENTER);
		label4.setBounds(95,72,210,26);
		add(label4);
		setTitle("Dialog1");
		//}}

    //{{REGISTER_LISTENERS
    SymWindow aSymWindow = new SymWindow();
    this.addWindowListener(aSymWindow);
    SymMouse aSymMouse = new SymMouse();
    okButton.addMouseListener(aSymMouse);
    cancelButton.addMouseListener(aSymMouse);
    //}}
  }
  
  public void addNotify()
  {
      // Record the size of the window prior to calling parents addNotify.
    Dimension d = getSize();

    super.addNotify();

    if (fComponentsAdjusted)
      return;

    // Adjust components according to the insets
    setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
    Component components[] = getComponents();
    for (int i = 0; i < components.length; i++)
    {
      Point p = components[i].getLocation();
      p.translate(insets().left, insets().top);
      components[i].setLocation(p);
    }
    fComponentsAdjusted = true;
  }

  // Used for addNotify check.
  boolean fComponentsAdjusted = false;


  public DelHostDialog(Frame parent, String title, boolean modal)
  {
    this(parent, modal);
    setTitle(title);
  }
  
  public DelHostDialog(Frame parent, String title,boolean modal, Admin appl, int index)
  {
    this(parent,title,modal);
    applParent=appl;
    hostIndex=index;
  }

  /**
   * Shows or hides the component depending on the boolean flag b.
   * @param b  if true, show the component; otherwise, hide the component.
   * @see java.awt.Component#isVisible
   */
  public void setVisible(boolean b)
  {
    if(b)
    {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();
  
      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
         bounds.y + (bounds.height - abounds.height)/2);
    }
    super.setVisible(b);
  }

  //{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Button okButton;
	java.awt.Button cancelButton;
	java.awt.Label label3;
	java.awt.Label label4;
	//}}

  class SymWindow extends java.awt.event.WindowAdapter
  {
    public void windowClosing(java.awt.event.WindowEvent event)
    {
      Object object = event.getSource();
      if (object == DelHostDialog.this)
        DelHostDialog_WindowClosing(event);
    }
  }
  
  void DelHostDialog_WindowClosing(java.awt.event.WindowEvent event)
  {
    setVisible(false);
  }

  class SymMouse extends java.awt.event.MouseAdapter
  {
    public void mouseClicked(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == okButton)
        okButton_MouseClicked(event);
      else if (object == cancelButton)
        cancelButton_MouseClicked(event);
    }
  }

  void okButton_MouseClicked(java.awt.event.MouseEvent event)
  {
    applParent.delHost(hostIndex);
    setVisible(false);
    dispose();
  }

  void cancelButton_MouseClicked(java.awt.event.MouseEvent event)
  {
    setVisible(false);
    dispose();
  }
}
