package PseudoProxy;

import java.net.*;
import java.io.*;

public class AdminThread extends Thread
{
  Socket appletSocket=null;
  BufferedReader in=null;
  DataOutputStream out=null;
  Config config=null;
  
  AdminThread(Config configObject,Socket appSock)
  {
    config=configObject;
    appletSocket=appSock;
  }//Fine costruttore
  
  public void run()
  {
    config.openAdminThread();
    try
    {
      //si gestisce la richiesta dal client
      in = new BufferedReader(new InputStreamReader(appletSocket.getInputStream()));
      out = new DataOutputStream(appletSocket.getOutputStream());
      String request=in.readLine();
      //se la richiesta  da parte dell'applet "admin"
      if (request.equals("ADMIN"))
      {
        while(config.getIsBusy())
        {}
        config.setIsBusy(true);
        //si invia la config
        out.writeBytes(config.toString());
        out.flush();
        if (in.readLine().equals("OK"))
        {
          //si riceve la nuova configurazione dall'applet
          //e si passa alla config
          config.parse(in.readLine());
        }
        config.setIsBusy(false);
      }
      else if (request.equals("TIMECOUNTER"))
      //la richiesta  da parte dell'applet TimeCounter
      //che conta il tempo di lettura di un documento
      {
        //si invia un messaggio di accettazione
        out.writeBytes("ACCEPT\n");
        out.flush();
        //si ricevono i dati
        int host=Integer.parseInt(in.readLine());
        int doc=Integer.parseInt(in.readLine());
        long time=Long.parseLong(in.readLine());
        config.updateDocList(host,doc,time);
        config.closeThread();
      }
      else if(request.equals("USERINFO"))
      //la richiesta  da parte dell'applet 
      //che riconosce l'utente
      {
        //si invia un messaggio di accettazione
        out.writeBytes("ACCEPT\n");
        out.flush();
        //si ricevono i dati
        request=in.readLine(); 
        int host=config.isInHostList(request);
        if (host>-1)
        {
          request=in.readLine();
          config.saveUserInfo(request,host);
          //config.setIsObserved(host,2);
          //config.setIsObserved(host,true);
          out.writeBytes("INSERTOK\n");
          out.flush();
        }
        else
        {
          out.writeBytes("ERROR\n");
          out.flush();
        }
      }
      else 
      {}
    }
    catch (Exception e)
    {}
    finally
    {
      config.closeAdminThread();
      try
      {
        out.close();
        in.close();
        appletSocket.close();
      }
      catch(Exception exc)
      {}
    }
  }//Fine run

}//Fine classe AdminThread
