package PseudoProxy;

import java.net.*;
import java.io.*;
import java.util.StringTokenizer;

public class Config
{
  private String adminPath;
  private int adminPort;
  private String localHost;
  private String localIP;
  private boolean isFatherProxy;
  private String fatherProxyHost;
  private int fatherProxyPort;
  private String password;
  private InfoHost listOfHost[];  
  private int numHost;
  private int startHour, startMin;
  private int numThreads;
  private int numAdminThreads;
  private boolean isAppletContext;
  private boolean serverAlive;
  private boolean isBusy;
  private static final String separator=" ";
  
  public Config()
  {
    isFatherProxy=false;
    fatherProxyHost=new String();
    fatherProxyPort=8080;
    password="admin";
    isAppletContext=false;
    isBusy=false;
    listOfHost=new InfoHost[0];
    numHost=0;
    startHour=0;
    startMin=0;
    numThreads=0;
    numAdminThreads=0;    
  }// Fine costruttore
  
  public int getLastFatherDoc(int host)
  {
    return listOfHost[host].lastFatherDoc;
  }
  
  public void setLastFatherDoc(int lfd,int host)
  {
    listOfHost[host].lastFatherDoc=lfd;
  }
  
  public void setLinkFatherDoc(int lfd,int host)
  {
    listOfHost[host].actualHtmlDoc=lfd;
  }
  
  public int getLinkFatherDoc(int host)
  {
    return listOfHost[host].actualHtmlDoc;
  }
  
  public void setLocalHost(String host)
  {
    localHost=host;
  }
  
  public String getLocalHost()
  {
    return localHost;
  }
  
  public void setLocalIP(String IP)
  {
    localIP=IP;
  }
  
  public String getLocalIP()
  {
    return localIP;
  }
  
  public void setAdminPath(String adPath)
  {
    adminPath=adPath;
  }
  
  public String getAdminPath()
  {
    return adminPath;    
  }
  
  public void setAdminPort(int port)
  {
    adminPort=port;
  }
  
  public int getAdminPort()
  {
    return adminPort;
  }

  public synchronized void setIsFatherProxy(boolean fatherProxy)
  {
    isFatherProxy=fatherProxy;
  }
  
  public boolean getIsFatherProxy()
  {
    return isFatherProxy;
  }
  
  public boolean getIsAppletContext()
  {
    return isAppletContext;
  }
  
  public synchronized void setIsAppletContext(boolean applCon)
  {
    isAppletContext=applCon;
  }
  
  public boolean getServerAlive()
  {
    return serverAlive;
  }
  
  public void setServerAlive(boolean state)
  {
    serverAlive=state;
  }
  
  public boolean getIsBusy()
  {
    return isBusy;
  }
  
  public synchronized void setIsBusy(boolean busy)
  {
    isBusy=busy;
  }
  
  public synchronized void setFatherProxyHost(String host)
  {
    fatherProxyHost=host;
  }
  
  public String getFatherProxyHost()
  {
    return fatherProxyHost;
  }
  
  public synchronized void setFatherProxyPort(int port)
  {
    fatherProxyPort=port;
  }
  
  public int getFatherProxyPort()
  {
    return fatherProxyPort;
  }
  
  public synchronized void setPassword(String pass)
  {
    password=pass;
  }
  
  public String getPassword()
  {
    return password;
  }
  
  public synchronized void setStartTime(int hour, int min)
  {
    startHour=hour;
    startMin=min;
  }
  
  public int getStartHour()
  {
    return startHour;
  }
  
  public int getStartMin()
  {
    return startMin;
  }
  
  public void openThread()
  {
    numThreads++;
  }
  
  public void closeThread()
  {
    if (numThreads>0)
      numThreads--;
  }
  
  public int getThreads()
  {
    return numThreads;
  }
  
  public void openAdminThread()
  {
    numAdminThreads++;
  }
  
  public void closeAdminThread()
  {
    if (numAdminThreads>0)
      numAdminThreads--;
  }
  
  public int getAdminThreads()
  {
    return numAdminThreads;
  }
  
  public int getNumHost()
  {
    return numHost;
  }
  
  public void setNumHost(int num)
  {
    numHost=num;
  }
    
  public String getHost(int index)
  {
    return listOfHost[index].host;
  }
  
  public void delHost(String hostName)
  {
    InfoHost listApp[]=new InfoHost[listOfHost.length-1];
    for (int i=0; i<listOfHost.length; i++)
    {
      if (!(listOfHost[i].host.equals(hostName)))
        listApp[i]=listOfHost[i];
    }
    listOfHost=listApp;
    numHost=numHost-1;
  }//Fine delHost

  public void saveUserInfo(String userInfo, int host)
  {
    listOfHost[host].saveUserInfo(userInfo);
  }
  
  public int isInHostList(String host)
  {
    int i;
    for(i=0;i<listOfHost.length;i++)
      if (host.compareTo(listOfHost[i].host)==0||
          host.compareTo(listOfHost[i].hostIP)==0)
        return i;
    return -1;
  }//Fine isInHostList
  
  public int isInLinkList(String link,int host)
  {
    return listOfHost[host].isInLinkList(link);
  }
  
  public int isInDocList(String file,int host)
  {
    return listOfHost[host].isInDocList(file);
  }
  
  public int insertIntoDocList(String file,int host)
  {
    return listOfHost[host].insertIntoDocList(file);
  }

  public void insertIntoHostList(String host)
  {
    InfoHost listHostApp[]=new InfoHost[(listOfHost.length+1)];
    for (int i=0;i<listOfHost.length;i++)
      listHostApp[i]=listOfHost[i];
    listHostApp[listOfHost.length]=new InfoHost(host);
    listOfHost=listHostApp;
    numHost=numHost+1;
  }//Fine insertIntoHostList

  public void insertIntoLinkList(int host, String url, String type)
  {
    listOfHost[host].insertIntoLinkList(url,type);
  }
  
  public void saveLinkList(int host, int newDoc)
  {
    listOfHost[host].saveLinkList(newDoc);
  }
  
  public void loadLinkList(int host, int doc)
  {
    listOfHost[host].loadLinkList(doc);
  }
  
  public boolean isParsed(int host, int doc)
  {
    return listOfHost[host].isParsed(doc);
  }
  
  public void updateInterestFactor(int host, int doc, int value)
  {
    listOfHost[host].updateInterestFactor(doc,value);
  }

  public void updateDocList(int host, int doc, long time)
  {
    listOfHost[host].updateDocList(doc,time);
  }

  public void updateLinkList(int link, int host)
  {
    listOfHost[host].updateLinkList(link);
  }
  
  public boolean isObserved(int index)
  {
    return listOfHost[index].isObserved;
  }
  
  public void setIsObserved(int index, boolean isOb)
  {
    listOfHost[index].isObserved=isOb;
  }
  
  public void setLastSession(int host)
  {
    listOfHost[host].setLastSession();
  }
  
  public String getAppletUrl(int index)
  {
    return listOfHost[index].appletUrl;
  }
  
  public int getDbPort(int host)
  {
    return listOfHost[host].dbPort;
  }
  
  public InfoHost getInfoHost(int host)
  {
    return listOfHost[host];
  }
  
  // Costruisce una stringa con tutti i parametri
  public synchronized String toString()
  {
    int i;
    String s = "";
    s+=password+separator;
    s+=isFatherProxy+separator;
    if (fatherProxyHost.equals(""))
      s+="NULL"+separator;
    else
      s+=fatherProxyHost+separator;
    s+=fatherProxyPort+separator;
    s+=startHour+separator;
    s+=startMin+separator;
    s+=numHost+separator;
    for(i=0;i<numHost;i++)
      s+=getHost(i)+separator;
    s+="\n";
    return s;
  }//fine toString

  // Setta i parametri secondo la stringa inviata dall'applet
  public synchronized void parse(String config)
  {
    int index,i;
    String host;
    String newListOfHost[];
    StringTokenizer s=new StringTokenizer(config,separator);
    password=s.nextToken();
    isFatherProxy=s.nextToken().equals("true");
    fatherProxyHost=s.nextToken();
    if(fatherProxyHost.equals("NULL"))
      fatherProxyHost=""; 
    fatherProxyPort=Integer.parseInt(s.nextToken());
    startHour=Integer.parseInt(s.nextToken());
    startMin=Integer.parseInt(s.nextToken());
    int newNumHost=Integer.parseInt(s.nextToken());
    newListOfHost=new String[newNumHost];
    //se siamo in un config locale o 
    //se il config  stato appena creato
    if ((isAppletContext)||(listOfHost.length==0))
      for (i=0;i<newNumHost;i++)
        insertIntoHostList(s.nextToken());
    //altrimenti siamo in un config globale
    else
    {
      for (i=0;i<newNumHost;i++)
        newListOfHost[i]=s.nextToken();
      InfoHost app[]=new InfoHost[newNumHost];
      for (i=0;i<newNumHost;i++)
        if ((index=isInHostList(newListOfHost[i]))>-1)
          app[i]=listOfHost[index];
        else
          app[i]=new InfoHost(newListOfHost[i]);
      listOfHost=app;
    }
  }//Fine parse
  
}// Fine classe Config
