package PseudoProxy;

import java.io.*;
import java.util.*;

public class DaemonThread extends Thread
{
    private Config config;
    private int startHour;
    private int startMin;
    private long sleepTime;
    private int numThreads;

    public DaemonThread(Config cfg)
    {
        config=cfg;
        startHour=config.getStartHour();
        startMin=config.getStartMin();
        numThreads=0;
    }//Fine costruttore
    
    public void run()
    {
      Date now;
      int thisHour, thisMin;
      long thisTime, startTime;
      //loop fino a che il proxy-server  attivo
      try
      {
        while(config.getServerAlive())
        {
          now=new Date();
          thisHour=now.getHours();
          thisMin=now.getMinutes();
          startTime=(((startHour*60)+startMin)*60);
          if (thisHour<startHour)
          {
            thisTime=(((thisHour*60)+thisMin)*60);
            sleepTime=(startTime-thisTime)*1000;
          }
          else if (thisHour>startHour)
          {
            thisTime=(((thisHour*60)+thisMin)*60);
            sleepTime=((86400-thisTime)+startTime)*1000;
          }
          else
          {
            if (thisMin<startMin)
              sleepTime=(startMin-thisMin)*60000;
            else
              sleepTime=0;
          }
          sleep(sleepTime);
          //se non ci sono thread che girano
          if (config.getThreads()==0)
            saveData();
        }//Fine loop
      }
      catch (InterruptedException ie)
      {}
      finally
      {
        saveData();
        //si attende che l'ultimo thread abbia finito
        while(numThreads>0)
        {}
      }
    }//Fine run
    
    private void saveData()
    {
      InfoHost actualHost;
      int numHost=config.getNumHost();
      for(int i=0; i<numHost; i++)
      {
        actualHost=config.getInfoHost(i);
        SaverThread saverThd=new SaverThread(this,actualHost);
        saverThd.start();
        openThread();
      }
    }//fine saveData
    
    public void openThread()
    {
      numThreads++;
    }
    
    public void closeThread()
    {
      if (numThreads>0)
        numThreads--;
    }

}//Fine classe DaemonThread