package PseudoProxy;

import java.io.*;
import java.util.StringTokenizer;
import java.net.*;

public class HtmlResponseBody
{
  private String listOfLink[]=null;
  Config config=null;
  private String baseUrl;
  private String actualBase;
  private String messageBody;
  private String contentType;
  private String linkUrl;
  private int host;
  private static String SP=" ";
  
  public HtmlResponseBody(Config conf, String url,int hostIndex)
  {
    config=conf;
    baseUrl=new String(url);
    actualBase=new String(baseUrl);
    messageBody=new String();
    contentType=new String();
    linkUrl=new String();
    host=hostIndex;
  }//Fine costruttore

  public void parse(String mess)
  {
    /*
    HTML-document=HTML-Version-Information
                  Header-Section
                  Body-Section
                  "</HTML>"
    HTML-Version-Information=HTML-Element
    HTML-Element="<!DOCTYPE HTML PUBLIC" Information ">"
    Header-Section="<HEAD>" *(Header-Section-Element) "</HEAD>"
    Body-Section="<BODY>" *(Body-Section-Element) "</BODY>"
    */
    String headSection=new String();
    String bodySection=new String();
    String workString=new String();
    //int bufferLength;
    //byte buffByte[];
    int index;
    
    messageBody=new String(mess);
    if (mess.length()>0)
    {
      try
      {
        //prima ricerca dei link nella header-section
        headSection=messageBody.substring(messageBody.toUpperCase().indexOf("<HEAD"),
                                          messageBody.toUpperCase().indexOf("</HEAD>")+7);
        bodySection=messageBody.substring(messageBody.toUpperCase().indexOf("</HEAD>")+7);
        //Ricerca del base-tag
        if ((index=headSection.toUpperCase().indexOf("<BASE"))>-1)
        {
          //<BASE SP href=[SP] "Url" [SP] >
          //Sostituire la baseUrl
          workString=headSection.substring(index);
          workString=workString.substring(workString.toLowerCase().indexOf("href"),
                                          workString.indexOf(">"));
          baseUrl=workString.substring(workString.indexOf("=")+1).trim();
          baseUrl=delQuotes(baseUrl);
        }
        //ricerca di link-tag
        while ((index=headSection.toUpperCase().indexOf("<LINK"))>-1)
        {
          //se esiste un nuovo tag <LINK>
          actualBase=new String(baseUrl);
          contentType="";
          linkUrl="";
          //<LINK SP (...) SP type=[SP]ContentType SP (...) SP href=[SP]Url SP (...)>
          headSection=headSection.substring(index);
          getLinkData(headSection);
          //inserire il link nel linkList
          insertLink(contentType,linkUrl);
          headSection=headSection.substring(headSection.indexOf(">")+1);
        }
        //prosegue la ricerca dei link nella body-section
        index=bodySection.toUpperCase().indexOf("<BODY");
        if (index>-1)
        {
          //la body-section del documento non ha frame
          String saveBodySection=new String(bodySection);
          //ricerca degli anchor-tag 
          while ((index=bodySection.toUpperCase().indexOf("<A "))>-1)
          {
            actualBase=new String(baseUrl);
            contentType="";
            linkUrl="";
            //se esiste un nuovo tag <A>
            bodySection=bodySection.substring(index);
            //<A SP (...) SP type=[SP]ContentType SP (...) SP href=[SP]Url SP (...)>
            getAnchorData(bodySection);
            //inserire il link nel linkList
            insertLink(contentType,linkUrl);
            bodySection=bodySection.substring(bodySection.indexOf(">")+1);
          }
          //ricerca degli object-tag
          bodySection=new String(saveBodySection);
          while ((index=bodySection.toUpperCase().indexOf("<OBJECT "))>-1)
          {
            actualBase=new String(baseUrl);
            contentType="";
            linkUrl="";
            //se esiste un nuovo tag <OBJECT>
            bodySection=bodySection.substring(index);
            getObjectData(bodySection);
            //inserire il link nel linkList
            insertLink(contentType,linkUrl);
            bodySection=bodySection.substring(bodySection.indexOf(">")+1);
          }
        } 
      }
      catch (Exception e)
      {
        System.out.println(e.getMessage());
      }
    }//Fine if
  }//Fine parse
  
  public String getMessageBody()
  {
    return messageBody;
  }
  
  public void setMessageBody(String mess)
  {
     messageBody=new String(mess);
  }//Fine setMessageBody
  
  // Elimina le virgolette davanti e in fondo alla stringa
  //Da "stringa" restituisce stringa
  private String delQuotes(String quotedString)
  {
    String str=new String(quotedString);
    if (str.startsWith("\""))
      str=str.substring(1);
    if (str.endsWith("\""))
      str=str.substring(0,str.length()-1);
    return str;
  }//Fine delQuotes
  
  public int insertApplet(int host, int doc, String localHost, String appletPath, int port)
  //public int insertApplet(int host, int doc, String appletPath, int port)
  {
    //N.B. l'applet deve stare nella directory 
    //in cui si trova l'admin-applet
    //String appletUrl=new String(localHost);
    /*
    if (!((appletUrl.endsWith("/"))&&(appletPath.startsWith("/"))))
      appletUrl+="\\\\"+appletPath;
    else if (appletUrl.endsWith("/") && appletPath.startsWith("/"))
      appletUrl+=appletPath.substring(1);
    else
      appletUrl+=appletPath;
    /*
    if (appletUrl.endsWith("/"))
      appletUrl+="TimeCounter.class";
    else
      appletUrl+="/TimeCounter.class";
    */
    String appletTag=new String();
    /*
    appletTag="<OBJECT codetype=\"application/java\" classid="
              +appletUrl+" width=0 height=0>\n";
    */
    appletTag="<APPLET codebase=\"/"+appletPath+"\" code=\"TimeCounter.class\" width=3 height=3>\n";
    appletTag+="<PARAM name=hostIndex value="
               +host+">\n";
    appletTag+="<PARAM name=docIndex value="
               +doc+">\n";
    appletTag+="<PARAM name=adminHost value="
               +localHost+">\n";
    appletTag+="<PARAM name=adminPort value="
               +port+">\n";
    appletTag+="</APPLET>\n";
    //si inserisce l'appletTag nel file HTML
    String newMessageBody=new String();
    int index=messageBody.toUpperCase().indexOf("</BODY");
    //la body-section del documento non ha frame
    if (index>-1)
    {
      newMessageBody=messageBody.substring(0,index);
      newMessageBody+=appletTag;
      newMessageBody+=messageBody.substring(index);
      messageBody=new String(newMessageBody);
    }
    //altrimenti la body-section ha dei frame
    else
    {}
    return messageBody.length();
  }//Fine insertApplet
  
  private void insertLink(String type, String url)
  {
    int index;
    String finalUrl=new String();
    boolean relativeUrl=false;
    /*
    //se non  un'application
    if (type.toLowerCase().indexOf("application")==-1)
    */
    //se  un testo
    if (type.toLowerCase().indexOf("text")>-1)
    {
      //se la url non  vuota...
      if (url.length()>0)
      {
        //url="scheme-lk://loc-net-lk/path-lk;params-lk?query-lk#fragment-lk"
        //...si elimina l'eventuale fragment-part
        if ((index=url.indexOf("#"))>-1)
          url=url.substring(0,index);
        //se la url  relativa, non contiene la scheme-part
        if (url.indexOf(":")==-1)
          relativeUrl=true;
      }
      //altrimenti la url  vuota
      //si user la url di base
      else
        relativeUrl=true;
      if (relativeUrl)
      {
        //si risolve con la actualBase
        //appBase = "scheme://loc-net/path;params?query#fragment"
        String appBase=new String(actualBase);
        if ((index=appBase.indexOf("#"))>-1)
          //si elimina la fragment-part da appBase
          //appBase = "scheme://loc-net/path;params?query"
          appBase=appBase.substring(0,index);
        if ((index=appBase.indexOf(":"))>-1)
        {
          //si elimina la scheme-part da appBase
          //finalUrl = "scheme:"
          //appBase = "//loc-net/path;params?query"
          finalUrl=appBase.substring(0,index+1);
          appBase=appBase.substring(index+1);
        }
        //se url="//loc-net-lk/path-lk;params-lk?query-lk"
        if (url.startsWith("//"))
        {
          //si elimina la net-loc-part dalla url
          finalUrl+=url.substring(0,2);
          url=url.substring(2);
          //se url="//loc-net-lk/path-lk;params-lk?query-lk"
          if ((index=url.indexOf("/"))>-1)
          {
            //finalUrl= "scheme://loc-net-lk/"
            //url="path-lk;params-lk?query-lk"
            finalUrl+=url.substring(0,index+1);
            url=url.substring(index+1);
            //si elimina la query-part da url
            if ((index=url.indexOf("?"))>-1)
              //url="path-lk;params-lk"
              url=url.substring(0,index);
            //si elimina la params-part da url
            if ((index=url.indexOf(";"))>-1)
              //url="path-lk"
              url=url.substring(0,index);
          }
          //finalUrl = "scheme://loc-net-lk/path-lk"
          //opure se url= "//loc-net-lk"
          //finalUrl = "scheme://loc-net-lk"
          finalUrl+=url;
        }
        //altrimenti url="path-lk;params-lk?query-lk"
        //devo considerare tutta la base
        else
        {
          //si elimina la net-loc-part da appBase
          if (appBase.startsWith("//"))
          {
            finalUrl+="//";
            appBase=appBase.substring(2);
            if ((index=appBase.indexOf("/"))>-1)
            {
              //finalUrl = "scheme://loc-net/"
              //appBase = "path;params?query"
              finalUrl=appBase.substring(0,index+1);
              appBase=appBase.substring(index+1);
            }
          }
          //si elimina la query-part da appBase
          if ((index=appBase.indexOf("?"))>-1)
            //finalUrl = "scheme://loc-net/"
            //appBase = "path;params"
            appBase=appBase.substring(0,index);
          //si elimina la params-part da appBase
          if ((index=appBase.indexOf(";"))>-1)
            //finalUrl = "scheme://loc-net/"
            //appBase = path
            //path = "dir1/dir2/dir3/(...)/dirN/file"
            //appBase = "dir1/dir2/dir3/(...)/dirN/file"
            //oppure, se non ci sono directory,
            //appBase = "file"
            appBase=appBase.substring(0,index);
          //se la url relativa non si riferisce 
          //allo stesso file indicato nella base...
          if (!((url.equals(""))||
                (url.startsWith("#"))||
                (url.startsWith(";"))||
                (url.startsWith("?"))))
          {
            //...si elimina il file da appBase...
            if ((index=appBase.lastIndexOf("/"))>-1)
              //appBase = "dir1/dir2/dir3/(...)/dirN-1/dirN/"
              //se non ci sono directory
              //appBase = stringa vuota
              //finalUrl = "scheme://loc-net/"
              appBase=appBase.substring(0,index+1);
            //...si inserisce la url relativa del link
            //se url="/path-lk"
            if (url.startsWith("/"))
            {
              //si azzera il path presente nella appBase
              //e si azzera il net-loc presente nella url
              //url="path-lk"
              //appBase=stringa vuota
              //cosicch avremo alla fine:
              //finalUrl="scheme://net-loc/path-lk"
              url=url.substring(1);
              appBase="";
            }
            //se url="./path-lk"
            else if (url.startsWith("./"))
            {
              //si elimina "./" dalla url
              //url="path-lk"
              //appBase="dir1/dir2/dir3/(...)/dirN-1/dirN/"
              //finalUrl="scheme://net-loc/"
              //cosicch avremo alla fine:
              //finalUrl="scheme://net-loc/dir1/dir2/dir3/(...)/dirN-1/dirN/path-lk"
              url=url.substring(2);
            }
            //se url="."
            else if (url.equals("."))
            {
              //si azzera la url relativa
              //avremo alla fine
              //finalUrl="scheme://net-loc/dir1/dir2/dir3/(...)/dirN-1/dirN/"
              url="";
            }
            else
            {
              //se url="../../(...)/path-lk"
              while (url.startsWith("../"))
              {
                if (appBase.length()>0)
                {
                  //si elimina l'ultima dir da appBase
                  //appBase = "dir1/dir2/dir3/(...)/dirN-1/dirN"
                  appBase=appBase.substring(0,appBase.lastIndexOf("/"));
                  //appBase = "dir1/dir2/dir3/(...)/dirN-1/"
                  appBase=appBase.substring(0,appBase.lastIndexOf("/")+1);
                  //si elimina "../" dalla url
                  url=url.substring(3);
                  //cosicch avremo alla fine:
                  //finalUrl="scheme://net-loc/dir1/dir2/(...)/path-lk"
                }
                else
                  //appBase = stringa vuota
                  //si elimina "../" dalla url
                  url=url.substring(3);
                //cosicch avremo alla fine:
                //finalUrl="scheme://net-loc//path-lk"
              }
            }
            finalUrl+=appBase+url;
          }
          //altrimenti la url si riferisce allo stesso file della base
          else
            //finalUrl = "scheme://loc-net/dir1/dir2/dir3/(...)/dirN/file"
            finalUrl+=appBase;
        }
      }
      //altrimenti la url  assoluta
      else
        finalUrl=new String(url);
      config.insertIntoLinkList(host,finalUrl,type);
    }
  }//Fine insertLink
  
  //private void getLinkData(String headS, String contentType, String linkUrl)
  private void getLinkData(String headS)
  {
    String workString=new String(headS);
    String appString="";
    workString=workString.substring(0,workString.indexOf(">"));
    int indexType=workString.toLowerCase().indexOf("type");
    int indexRef=workString.toLowerCase().indexOf("href");
    if (indexRef>-1)
    {
      if ((indexType<indexRef)&&(indexType>-1))
      {
        //<LINK SP (...) SP type=[SP]ContentType SP (...) SP href=[SP]Url SP (...)>
        //workString=workString.substring(indexType,workString.indexOf(">"));
        workString=workString.substring(indexType);
        workString=workString.substring(workString.indexOf("=")+1).trim();
        contentType=workString.substring(0,workString.indexOf(SP));
        contentType=delQuotes(contentType);
        workString=workString.substring(workString.toLowerCase().indexOf("href"));
        workString=workString.substring(workString.indexOf("=")+1).trim();
        if (workString.indexOf(SP)>-1)
          linkUrl=workString.substring(0,workString.indexOf(SP));
        else
          linkUrl=workString.toString();
        linkUrl=delQuotes(linkUrl);
      }
      else
      {
        //<LINK SP (...) SP href=[SP]Url SP (...) >
        //workString=workString.substring(indexRef,workString.indexOf(">"));
        workString=workString.substring(indexRef);
        workString=workString.substring(workString.indexOf("=")+1).trim();
        //linkUrl=workString.substring(0,workString.indexOf(SP));
        if (workString.indexOf(SP)>-1)
          linkUrl=workString.substring(0,workString.indexOf(SP));
        else
          linkUrl=workString.toString();
        linkUrl=delQuotes(linkUrl);
        if (linkUrl.toLowerCase().indexOf("html")>-1)
          contentType="text";
        else
          contentType="";
        if (indexType>-1)
        {
          //<LINK SP (...) SP href=[SP]Url SP (...) type=[SP]ContentType SP (...) >
          workString=workString.substring(workString.toLowerCase().indexOf("type"));
          workString=workString.substring(workString.indexOf("=")+1).trim();
          //contentType=workString.substring(0,workString.indexOf(SP));
          if (workString.indexOf(SP)>-1)
            contentType=workString.substring(0,workString.indexOf(SP));
          else
            contentType=workString.toString();
          contentType=delQuotes(contentType);
        }
      }
    }
  }//Fine getLinkData

  //private void getAnchorData(String bodyS, String contentType, String linkUrl)
  private void getAnchorData(String bodyS)
  {
    String workString=new String(bodyS);
    workString=workString.substring(0,workString.indexOf(">"));
    int indexType=workString.toLowerCase().indexOf("type");
    int indexRef=workString.toLowerCase().indexOf("href");
    if (indexRef>-1)
    {
      if ((indexType<indexRef)&&(indexType>-1))
      {
        //<A SP (...) SP type=[SP]ContentType SP (...) SP href=[SP]Url SP (...)>
        //workString=workString.substring(indexType,workString.indexOf(">"));
        workString=workString.substring(indexType);
        workString=workString.substring(workString.indexOf("=")+1).trim();
        contentType=workString.substring(0,workString.indexOf(SP));
        contentType=delQuotes(contentType);
        workString=workString.substring(workString.toLowerCase().indexOf("href"));
        workString=workString.substring(workString.indexOf("=")+1).trim();
        //linkUrl=workString.substring(0,workString.indexOf(SP));
        if (workString.indexOf(SP)>-1)
          linkUrl=workString.substring(0,workString.indexOf(SP));
        else
          linkUrl=workString.toString();
        linkUrl=delQuotes(linkUrl);
      }
      else
      {
        //<A SP (...) SP href=[SP]Url SP (...) >
        //workString=workString.substring(indexRef,workString.indexOf(">"));
        workString=workString.substring(indexRef);
        workString=workString.substring(workString.indexOf("=")+1).trim();
        if (workString.indexOf(SP)>-1)
          linkUrl=workString.substring(0,workString.indexOf(SP));
        else
          linkUrl=workString.toString();
        linkUrl=delQuotes(linkUrl);
        if (linkUrl.toLowerCase().indexOf("html")>-1)
          contentType="text";
        else
          contentType="";
        if (indexType>-1)
        {
          //<A SP (...) SP href=[SP]Url SP (...) type=[SP]ContentType SP (...) >
          workString=workString.substring(workString.toLowerCase().indexOf("type"));
          workString=workString.substring(workString.indexOf("=")+1).trim();
          //contentType=workString.substring(0,workString.indexOf(SP));
          if (workString.indexOf(SP)>-1)
            contentType=workString.substring(0,workString.indexOf(SP));
          else
            contentType=workString.toString();
          contentType=delQuotes(contentType);
        }
      }
    }
  }//Fine getAnchorData
  
  //private void getObjectData(String bodyS, String contentType, String linkUrl)
  private void getObjectData(String bodyS)
  {
    boolean typePresent=false;
    String workString=new String(bodyS);
    workString=workString.substring(0,workString.indexOf(">"));
    int indexType=workString.toLowerCase().indexOf(" type");
    int indexData=workString.toLowerCase().indexOf("data");
    int indexCodeType=workString.toLowerCase().indexOf("codetype");
    int indexCodeBase=workString.toLowerCase().indexOf("codebase");
    //int indexClassId=workString.toLowerCase().indexOf("classid");
    //si preleva il codebase
    if (indexCodeBase>-1)
    {
      //workString=workString.substring(indexCodeBase,workString.indexOf(">"));
      workString=workString.substring(indexCodeBase);
      workString=workString.substring(workString.indexOf("=")+1).trim();
      //actualBase=workString.substring(0,workString.indexOf(SP));
      if (workString.indexOf(SP)>-1)
        actualBase=workString.substring(0,workString.indexOf(SP));
      else
        actualBase=workString.toString();
      actualBase=delQuotes(actualBase);
    }
    //si preleva il codetype
    workString=new String(bodyS);
    if (indexCodeType>-1)
    {
      //workString=workString.substring(indexCodeType,workString.indexOf(">"));
      workString=workString.substring(indexCodeType);
      workString=workString.substring(workString.indexOf("=")+1).trim();
      //contentType=workString.substring(0,workString.indexOf(SP));
      if (workString.indexOf(SP)>-1)
        contentType=workString.substring(0,workString.indexOf(SP));
      else
        contentType=workString.toString();
      contentType=delQuotes(contentType);
      typePresent=true;
    }
    //se non  presente il codetype, si preleva il type
    workString=new String(bodyS);
    if ((indexType>-1)&&!typePresent)
    {
      //workString=workString.substring(indexType,workString.indexOf(">"));
      workString=workString.substring(indexType);
      workString=workString.substring(workString.indexOf("=")+1).trim();
      //contentType=workString.substring(0,workString.indexOf(SP));
      if (workString.indexOf(SP)>-1)
        contentType=workString.substring(0,workString.indexOf(SP));
      else
        contentType=workString.toString();
      contentType=delQuotes(contentType);
    }
    /*
    //se il link si riferisce ad un testo o ad una immagine
    //if ((contentType.indexOf("text")>-1)||(contentType.indexOf("image")>-1))
    */
    //se il link si riferisce ad un testo
    if (contentType.toLowerCase().indexOf("text")>-1)
    {
      //si preleva il data
      workString=new String(bodyS);
      if (indexData>-1)
      {
        //workString=workString.substring(indexData,workString.indexOf(">"));
        workString=workString.substring(indexData);
        workString=workString.substring(workString.indexOf("=")+1).trim();
        //linkUrl=workString.substring(0,workString.indexOf(SP));
        if (workString.indexOf(SP)>-1)
          linkUrl=workString.substring(0,workString.indexOf(SP));
        else
          linkUrl=workString.toString();
        linkUrl=delQuotes(linkUrl);
      }
    }
  }//Fine getObjectData
  
  //private void getImageData(String bodyS, String contentType, String linkUrl)
  private void getImageData(String bodyS)
  {
    String workString=new String(bodyS);
    workString=workString.substring(0,workString.indexOf(">"));
    int indexRef=workString.toLowerCase().indexOf("src");
    //<IMG SP (...) SP src=[SP]Url SP (...)>
    if (indexRef>-1)
    {
      //workString=workString.substring(indexRef,workString.indexOf(">"));
      workString=workString.substring(indexRef);
      workString=workString.substring(workString.indexOf("=")+1).trim();
      //linkUrl=workString.substring(0,workString.indexOf(SP));
      if (workString.indexOf(SP)>-1)
        linkUrl=workString.substring(0,workString.indexOf(SP));
      else
        linkUrl=workString.toString();
      linkUrl=delQuotes(linkUrl);
      contentType=new String("image/jpeg");
    }
  }//Fine getImageData
  
}//Fine class HtmlResponseBody
