package PseudoProxy;

import java.net.*;
import java.io.*;

public class HttpReplyHdr
{
  static String CRLF="\r\n";
  static String HTTP_PROTOCOL="HTTP/1.1";
  static String HTTP_SERVER="Java Pseudo Proxy";

  long   contentLength=0;
  String extraErrorString ="";

  public boolean addErrorDescription(String str)
  {
    extraErrorString = str;
    return true;
  }

  public String formOk(String ContentType,long  ContentLength, boolean close)
  {
    contentLength = ContentLength;
    String out =new String();
    out += HTTP_PROTOCOL + " 200 Ok" + CRLF;
    out += "Server: " + HTTP_SERVER  + CRLF;
    if (0 < ContentType.length())
      out += "Content-type: " + ContentType + CRLF;
    else
      out += "Content-Type: text/html" + CRLF;
    if (0 != contentLength)
      out += "Content-Length: " + Long.toString(contentLength) + CRLF;
    if (close)
      out+="Connection: close"+CRLF;
    out +=CRLF;
    return out;
  }

  private String formErrorBody(String Error,String Description)
  {
    String out;
    //Genera Error Body
    out  ="<HTML><HEAD><TITLE>";
    out += Error ;
    out +="</TITLE></HEAD>";
    out +="<BODY><H2>" + Error +"</H2>\n";
    out +="</P></H3>";
    out += Description;
    out +="</BODY></HTML>";
    return out;
  }

  private String formError(String Error, String Description)
  {
    /* Una HTTP RESPONCE HEADER ha questa forma:
    *
    * HTTP/1.0 200 OK
    * Date: Wednesday, 02-Feb-94 23:04:12 GMT
    * Server: NCSA/1.1
    * MIME-version: 1.0
    * Content-type: text/html
    * Content-length: 2345
    * \r\n
    */
    String body=formErrorBody(Error,Description);
    String header =new String();
    header +=HTTP_PROTOCOL +" " + Error + CRLF;
    header +="Server: " + HTTP_SERVER   + CRLF;
    header +="MIME-version: 1.0"        + CRLF;
    header +="Content-type: text/html"  + CRLF;
    header +="Content-Length: " + String.valueOf(body.length())+ CRLF;
    header += CRLF;
    header += body;
    return header;
  }


  public String formCreated()
  {
    return formError("201 Created","Object was created");
  }

  public String formAccepted()
  {
    return formError("202 Accepted","Object checked in");
  }

  public String  formPartial()
  {
    return formError("203 Partial","Only partail document available");
  }

  public String formMoved()
  {
    return formError("301 Moved","File has moved");
  }

  public String formFound()
  {
    return formError("302 Found","Object was found");
  }

  public String formMethod()
  {
    return formError("303 Method unseported","Method unseported");
  }

  public String formNotModified()
  {
    return formError("304 Not modified","Use local copy");
  }

  public String formUnautorized()
  {
    return formError("401 Unathorized","Unathorized use of this service");
  }

  public String formPaymentNeeded()
  {
    return formError("402 Payment required","Payment is required");
  }

  public String formForbidden()
  {
    return formError("403 Forbidden","You need permission for this service");
  }

  public String formNotFound()
  {
    return formError("404 Not_found","Requested object was not found");
  }

  public String formInternalError()
  {
    return formError("500 Internal server error","Server broke");
  }

  public String formNotImplemented()
  {
    return formError("501 Method not implemented","Service not implemented, programer was lazy");
  }

  public String formOverloaded()
  {
    return formError("502 Server overloaded","Try again latter");
  }

  public String formTimeout()
  {
    return formError("503 Gateway timeout","The connection timed out");
  }

  public String formServerNotFound()
  {
    return formError("503 Gateway timeout","The requested server was not found");
  }

  public String formNotAllowed()
  {
    return formError("403 Access Denied","Access is not allowed");
  }
}//Fine classe HttpReplyHdr
