package PseudoProxy;

import java.net.*;
import java.util.StringTokenizer;
import java.util.Date;

public class InfoHost
{
  public String host;
  public String hostIP;
  public boolean isObserved;
  //public int isObserved;
  public int dbPort;
  public int lastFatherDoc;
  public int actualHtmlDoc;
  public String appletUrl;
  private InfoDoc listOfDoc[];
  private InfoLink listOfLink[];
  private String login;
  private String password;
  private Date lastSession;
  //private static final long lowThreshold=20000;//20 secondi  
  private static final long lowThreshold=1000;//20 secondi
  //private static final long highThreshold=3600000;//1 ora
  private static final long highThreshold=60000;//1 ora
  private final String separator=" ";

  public InfoHost(String h)
  {
    host=new String(h);
    try
    {
      hostIP=InetAddress.getByName(host).getHostAddress();
    }
    catch (UnknownHostException uhe)
    {
      hostIP=new String();
    }
    dbPort=5500;
    isObserved=false;
    lastFatherDoc=-1;
    //l'applet per il riconoscimento dell'utente
    //si trova nella directory userHelp del sito da monitorare
    appletUrl="userHelp";
    listOfDoc=new InfoDoc[0];
    listOfLink=new InfoLink[0];
    login=new String();
    password=new String();
    lastSession=null;
    actualHtmlDoc=-1;
  }//Fine costruttore
  
  public void saveUserInfo(String userInfo)
  {
    StringTokenizer s=new StringTokenizer(userInfo,separator);
    login=s.nextToken();
    password=s.nextToken();
    if (password.equals("NULL"))
      password="";
  }//Fine saveUserInfo
  
  public String getLogin()
  {
    return login;
  }
  
  public String getPassword()
  {
    return password;
  }
  
  public Date getLastSession()
  {
    return lastSession;
  }
  
  public void setLastSession()
  {
    lastSession=new Date();
  }
  
  public int isInDocList(String file)
  {
    int i,index;
    String appString=new String(file);
    String fileName=new String();
    //Una url pu essere cos composta
    //Url=<scheme>://<net_loc>/<path>;<params>?<query>#<fragment>
    //Togliamo la fragment-part
    if ((index=appString.indexOf("#"))>-1)
      appString=appString.substring(0,index);
    //togliamo la scheme-part
    if ((index=appString.indexOf(":"))>-1)
      appString=appString.substring(index+1);
    //togliamo la net-loc-part
    if (appString.startsWith("//"))
    {
      appString=appString.substring(2);
      if ((index=appString.indexOf("/"))>-1)
      {
        appString=appString.substring(index+1);
        //togliamo la query-part
        if ((index=appString.indexOf("?"))>-1)
          appString=appString.substring(0,index);
        //togliamo la params-part
        if ((index=appString.indexOf(";"))>-1)
          appString=appString.substring(0,index);
      }
    }
    //salviamo la path-part
    fileName+=appString;
    //Ora in fileName abbiamo <path>
    for(i=0;i<listOfDoc.length;i++)
      if (fileName.compareTo(listOfDoc[i].fileName)==0)
        return i;
    return -1;
  }//Fine isInDocList
  
  public int insertIntoDocList(String file)
  {
    int i;
    InfoDoc listDocApp[]=new InfoDoc[(listOfDoc.length+1)];
    for (i=0;i<listOfDoc.length;i++)
      listDocApp[i]=listOfDoc[i];
    listDocApp[listOfDoc.length]=new InfoDoc(file);
    listOfDoc=listDocApp;
    return i;
  }//Fine insertIntoDocList
  
  public int getNumDoc()
  {
    return listOfDoc.length;
  }
  
  public InfoDoc getDoc(int docIndex)
  {
    return listOfDoc[docIndex];
  }
  
  public String getLastDoc()
  {
    return listOfDoc[actualHtmlDoc].fileName;
  }
  
  public void resetData()
  {
    listOfDoc=new InfoDoc[0];
    listOfLink=new InfoLink[0];
    actualHtmlDoc=-1;
    isObserved=false;
    lastSession=null;
  }

  public int isInLinkList(String link)
  {
    int i,index;
    String appString=new String(link);
    String fileName=new String();
    //Una url pu essere cos composta
    //Url=<scheme>://<net_loc>/<path>;<params>?<query>#<fragment>
    //Togliamo la fragment-part
    if ((index=appString.indexOf("#"))>-1)
      appString=appString.substring(0,index);
    //togliamo la scheme-part
    if ((index=appString.indexOf(":"))>-1)
      appString=appString.substring(index+1);
    //salviamo la net-loc-part
    if (appString.startsWith("//"))
    {
      appString=appString.substring(2);
      if ((index=appString.indexOf("/"))>-1)
      {
        fileName+=appString.substring(0,index+1);
        appString=appString.substring(index+1);
        //togliamo la query-part
        if ((index=appString.indexOf("?"))>-1)
          appString=appString.substring(0,index);
        //togliamo la params-part
        if ((index=appString.indexOf(";"))>-1)
          appString=appString.substring(0,index);
      }
    }
    //salviamo la path-part
    fileName+=appString;
    //Ora in fileName abbiamo <net-loc>/<path>
    for(i=0;i<listOfLink.length;i++)
      if (fileName.compareTo(listOfLink[i].url)==0)
        return i;
    return -1;
  }//Fine isInLinkList

  public void updateInterestFactor(int doc, int value)
  {
    if (listOfDoc[doc].interestFactor<1.0)
      listOfDoc[doc].interestFactor+=(float)value/10;
    if (listOfDoc[doc].fileName.toLowerCase().indexOf("html")<=-1)
      listOfDoc[doc].numbOfTime++;
  }

  public void updateDocList(int doc, long time)
  {
    //si considera letto il documento solo se
    //l'utente vi si  soffermato un tempo 
    //compreso tra due valori soglia
    if ((time>=lowThreshold)&&(time<=highThreshold))
    {
      listOfDoc[doc].numbOfTime++;
      listOfDoc[doc].timeOfReading+=time;
    }
  }//Fine updateDocList
  
  public void updateLinkList(int link)
  {
    listOfLink[link].followed=true;
  }//Fine updateLinkList

  public void saveLinkList(int newDoc)
  {
    if (actualHtmlDoc>-1)
      listOfDoc[actualHtmlDoc].saveLinkList(listOfLink);
    listOfLink=new InfoLink[0];
    actualHtmlDoc=newDoc;
  }
  
  public void loadLinkList(int doc)
  {
    listOfLink=listOfDoc[doc].loadLinkList();
  }
  
  public boolean isParsed(int doc)
  {
    return listOfDoc[doc].isParsed();
  }
  
  public void insertIntoLinkList(String url, String type)
  {
    int i;
    InfoLink listLinkApp[]=new InfoLink[(listOfLink.length+1)];
    for (i=0;i<listOfLink.length;i++)
      listLinkApp[i]=listOfLink[i];
    listLinkApp[listOfLink.length]=new InfoLink(url,type);
    listOfLink=listLinkApp;
  }//Fine insertIntoLinkList
  
  public int countDocRead()
  {
    int count=0;
    for (int i=0; i<listOfDoc.length; i++)
    {
      count+=listOfDoc[i].numbOfTime;
    }
    return count;
  }//Fine countDocRead
  
  public float getTimeFactor(int doc)
  {
    float numerator=(listOfDoc[doc].timeOfReading-lowThreshold);
    float denominator=(highThreshold-lowThreshold)*listOfDoc[doc].numbOfTime;
    float tFactor;
    if ((numerator>0) && (denominator>0))
      tFactor=numerator/denominator;
    else 
      tFactor=0;
    return tFactor; 
  }//Fine getTimeFactor

}//Fine classe InfoHost
