/*
	A basic extension of the java.awt.Frame class
 */
package PseudoProxy;

import java.awt.*;

public class ProxyFrame extends Frame
{
  ProxyServer proxy;
  
	public ProxyFrame()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(401,226);
		label1 = new java.awt.Label("ProxyServer attivato.",Label.CENTER);
		label1.setBounds(68,36,265,24);
		add(label1);
		label2 = new java.awt.Label("Per chiudere cliccare su \"Chiudi\".",Label.CENTER);
		label2.setBounds(68,72,265,24);
		add(label2);
		button1 = new java.awt.Button();
		button1.setLabel("Chiudi");
		button1.setBounds(164,132,63,27);
		button1.setBackground(new Color(12632256));
		add(button1);
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		button1.addMouseListener(aSymMouse);
		//}}
	}

	public ProxyFrame(String title)
	{
		this();
		setTitle(title);
	}
	
	public ProxyFrame(String title, ProxyServer ps)
	{
	  this(title);
	  proxy=ps;
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new ProxyFrame()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Label label1;
	java.awt.Label label2;
	java.awt.Button button1;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == ProxyFrame.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_MouseClicked(event);
		}
	}

	void button1_MouseClicked(java.awt.event.MouseEvent event)
	{
	  proxy.stopProxy();
	  dispose();
	}
}
