package PseudoProxy;

import java.net.*;
import java.util.*;

public class SaverThread extends Thread
{
  DaemonThread father;
  InfoHost actualHost;
  ThreeTierOperator t3toper;

  public SaverThread(DaemonThread dthd, InfoHost host)
  {
    father=dthd;
    actualHost=host;
  }//fine costruttore

  public void run()
  {
    InfoDoc actualDoc;
    String login;
    String password;
    float value;
    
    //se l'attuale host considerato
    //ha delle modifiche da salvare
    int numDoc=actualHost.getNumDoc();
    if (numDoc>0)
    {
      //ND=numero di volte che l'utente ha letto un qualsiasi
      //   documento del sito
      int ND=actualHost.countDocRead();
      //inserire i dati nel DB utenti
      t3toper=new ThreeTierOperator(actualHost.host,
                                    actualHost.dbPort);
      //si prende l'argomento associato all'ultimo 
      //documento letto dall'utente
      int arg=t3toper.getArgument(actualHost.getLastDoc());
      login=actualHost.getLogin();
      password=actualHost.getPassword();
      //aggiornamento tabella UTENTE REALE
      t3toper.updateUserData(login,
                             password,
                             actualHost.getLastSession(),
                             arg);
      //per ogni documento visitato nell'host...
      for (int i=0; i<numDoc; i++)
      {
        actualDoc=actualHost.getDoc(i);
        //...si preleva il numero di link del documento 
        //seguiti dall'utente
        int numLink=actualDoc.getFollowedLink();
        //aggiornamento valutazioni della conoscenza 
        //e degli interessi dell'utente
        //***VALUTAZIONE DEL PUNTEGGIO***//
        //se indichiamo con
        //V=valore finale del punteggio
        //TL=Tempo di lettura
        //N=numero di volte che il documento  stato letto
        //NL=numero di link del documento seguiti
        //FI=fattore di interesse
        //TMAX=tempo massiomo considerato per la lettura (1ora)
        //TMIN=tempo minimo considerato per la lettura (20 secondi)
        //ND=numero di volte che l'utente ha letto un qualsiasi
        //   documento del sito
        //LT=Numero di link totali, per ogni documento
        //si ha che V=f(TL,N,NL,FI,TMAX,TMIN,ND,LT)
        //V=(0.3*tFactor+0.4*dFactor+0.3*lFactor)*FI
        //tFactor=(TL-TMIN)/(N*(TMAX-TMIN))
        //tFactor=TL/N
        //dFactor=N/ND
        //lFactor=NL/LT
        float tFactor=actualHost.getTimeFactor(i);
        float dFactor=(float)actualDoc.numbOfTime/ND;
        float lFactor=0;
        int totLink=0;
        if ((totLink=actualDoc.getListLength())>0)
          lFactor=(float)numLink/totLink;
        value=((3f/10)*tFactor+(4f/10)*dFactor+(3f/10)*lFactor)*(actualDoc.interestFactor+1)*100;
        t3toper.updateUserInterest(login,
                                   actualDoc.fileName,
                                   value);
      }
      //aggiornare l'utente medio che
      //rappresenta l'utente attuale
      t3toper.updateAverageUser(login);
      //salvare nel DB locale
      //***sviluppi futuri***//
      //reset dati
      actualHost.resetData();
    }
    father.closeThread();
  }//Fine run

}//Fine classe SaverThread