package PseudoProxy;

import java.net.*;
import java.io.*;
import java.util.Date;

public class ThreeTierOperator
{
  private String dbHost;
  private int dbPort;
  private Socket dbSocket;
  private DataOutputStream out;
  private BufferedReader in;

  public ThreeTierOperator(String host, int port)
  {
    dbHost=new String(host);
    dbPort=port;
  }//Fine costruttore
  
  //inserisce i dati dell'utente nel DB
  //ritorna il login associato a tale utente
  //se ci sono problemi nell'inserimento
  //ritorna "NULL"
  public String insertNewUser(String password,
                              String name,
                              String surname,
                              String category,
                              int age)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 1
      out.writeBytes(1+"\n");
      //Numero parametri: 5
      //Parametri
      out.writeBytes(password+"\n");
      out.writeBytes(name+"\n");
      out.writeBytes(surname+"\n");
      out.writeBytes(category+"\n");
      out.writeBytes(age+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      String response=in.readLine();
      out.close();
      in.close();
      dbSocket.close();
      return response;
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return "NULL";
    }
  }//Fine insertNewUser
  
  public boolean getUserAt(String login, String password)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 2
      out.writeBytes(2+"\n");
      //Numero parametri: 2
      //Parametri
      out.writeBytes(login+"\n");
      out.writeBytes(password+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      String response=in.readLine();
      out.close();
      in.close();
      dbSocket.close();
      return response.equals("TRUE");
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return false;
    }
  }//Fine getUserAt
  
  public int getArgument(String doc)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 3
      out.writeBytes(3+"\n");
      //Numero parametri: 1
      //Parametri
      out.writeBytes(doc+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      int response=Integer.parseInt(in.readLine());
      out.close();
      in.close();
      dbSocket.close();
      return response;
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return -1;
    }
  }//Fine getArgument
  
  public void updateUserData(String login,
                             String password,
                             Date lastSession,
                             int argument)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 4
      out.writeBytes(4+"\n");
      //Numero parametri: 4
      //Parametri
      out.writeBytes(login+"\n");
      out.writeBytes(password+"\n");
      out.writeBytes(lastSession.getTime()+"\n");
      out.writeBytes(argument+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      String response=in.readLine();
      out.close();
      in.close();
      dbSocket.close();
      return;
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return;
    }
  }//Fine updateUserData
  
  public void updateUserInterest(String login,
                                 String doc,
                                 float value)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 5
      out.writeBytes(5+"\n");
      //Numero parametri: 4
      //Parametri
      out.writeBytes(login+"\n");
      out.writeBytes(doc+"\n");
      out.writeBytes(value+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      String response=in.readLine();
      out.close();
      in.close();
      dbSocket.close();
      return;
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return;
    }
  }//Fine updateUserInterest
  
  public void updateAverageUser(String userLogin)
  {
    try
    {
      dbSocket=new Socket(dbHost,dbPort);
      out=new DataOutputStream(dbSocket.getOutputStream());
      in=new BufferedReader(new InputStreamReader(dbSocket.getInputStream()));
      //Codice operazione: 6
      out.writeBytes(6+"\n");
      //Numero parametri: 1
      //Parametri
      out.writeBytes(userLogin+"\n");
      //Invio
      out.flush();
      //Lettura risposta
      String response=in.readLine();
      out.close();
      in.close();
      dbSocket.close();
      return;
    }
    catch (Exception e)
    {
      try
      {
        out.close();
        in.close();
        dbSocket.close();
      }
      catch (Exception e2)
      {}
      return;
    }    
  }//Fine updateAverageUser

}//Fine classe ThreeTierOperator