import java.awt.*;

public class ErrorDialog extends Dialog
{

  public ErrorDialog(Frame parent, boolean modal)
  {
    super(parent, modal);
    //{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(350,170);
		okButton = new java.awt.Button();
		okButton.setLabel("OK");
		okButton.setBounds(152,120,45,25);
		okButton.setBackground(new Color(12632256));
		add(okButton);
		label1 = new java.awt.Label("",Label.CENTER);
		label1.setBounds(32,25,285,25);
		add(label1);
		label2 = new java.awt.Label("",Label.CENTER);
		label2.setBounds(32,72,285,25);
		add(label2);
		setTitle("Dialog1");
		//}}

    //{{REGISTER_LISTENERS
    SymWindow aSymWindow = new SymWindow();
    this.addWindowListener(aSymWindow);
    SymMouse aSymMouse = new SymMouse();
    okButton.addMouseListener(aSymMouse);
    //}}
  }

  public void addNotify()
  {
      // Record the size of the window prior to calling parents addNotify.
    Dimension d = getSize();

    super.addNotify();

    if (fComponentsAdjusted)
      return;

    // Adjust components according to the insets
    setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
    Component components[] = getComponents();
    for (int i = 0; i < components.length; i++)
    {
      Point p = components[i].getLocation();
      p.translate(insets().left, insets().top);
      components[i].setLocation(p);
    }
    fComponentsAdjusted = true;
  }

  // Used for addNotify check.
  boolean fComponentsAdjusted = false;


  public ErrorDialog(Frame parent, String title, boolean modal)
  {
    this(parent, modal);
    setTitle(title);
  }
  
  public ErrorDialog(Frame parent, String title, String message, boolean modal)
  {
    this(parent, modal);
    setTitle(title);
    label1.setText(message);
    if (title.toUpperCase().indexOf("OK")>-1)
    {
      label2.setText("");
      label2.setVisible(false);
    }
    else
    {
      label2.setText("Reinserire i dati e riprovare. Grazie!");
      label2.setVisible(true);
    }
  }

  /**
   * Shows or hides the component depending on the boolean flag b.
   * @param b  if true, show the component; otherwise, hide the component.
   * @see java.awt.Component#isVisible
   */
  public void setVisible(boolean b)
  {
    if(b)
    {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
         bounds.y + (bounds.height - abounds.height)/2);
    }
    super.setVisible(b);
  }

  //{{DECLARE_CONTROLS
	java.awt.Button okButton;
	java.awt.Label label1;
	java.awt.Label label2;
	//}}

  class SymWindow extends java.awt.event.WindowAdapter
  {
    public void windowClosing(java.awt.event.WindowEvent event)
    {
      Object object = event.getSource();
      if (object == ErrorDialog.this)
        ErrorDialog_WindowClosing(event);
    }
  }

  void ErrorDialog_WindowClosing(java.awt.event.WindowEvent event)
  {
    setVisible(false);
  }

  class SymMouse extends java.awt.event.MouseAdapter
  {
    public void mouseClicked(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == okButton)
        okButton_MouseClicked(event);
    }
  }

  void okButton_MouseClicked(java.awt.event.MouseEvent event)
  {
    setVisible(false);
    dispose();
  }

}//Fine classe ErrorDialog
