import java.net.*;
import java.io.*;
import java.util.Date;

public class ThreeTierServer extends Thread
{
  DaemonDBThread dbThd;
  int port;

  public ThreeTierServer()
  {
    this(5500);
  }

  public ThreeTierServer(int port)
  {
    super();
    dbThd=null;
    try
    {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch (ClassNotFoundException cnfe)
    {}
    this.port=port;
  }//Fine costruttore

    public void run()
    {
      System.out.println("Server attivo...");
      try
      {
        //Creare e avviare il demone che aggiorna il DB
        dbThd=new DaemonDBThread();
        dbThd.start();
        ServerSocket server=new ServerSocket(port);
        //loop
        while(true)
        {
          Socket client=server.accept();
          ThreeTierHandler handler=new ThreeTierHandler(client);
          handler.start();
        }
      }
      catch (IOException ioe)
      {
        System.out.println("Errore nella creazione del ServerSocket"+ioe);
      }
      finally
      {
        try
        {
          dbThd.interrupt();
        }
        catch (Exception e)
        {}
      }
    }//Fine run
    
    public static void main(String str[])
    {
      int port=5500;
      if (str.length>0)
      {
        try
        {
          port=Integer.parseInt(str[0]);
        }
        catch (NumberFormatException nfe)
        {
          port=5500;
        }
      }
      ThreeTierServer dbServer=new ThreeTierServer(port);
      dbServer.start();
    }//Fine main

}//Fine classe ThreeTierServer