import java.sql.*;
import java.util.*;
import java.io.*;

public class TwoTierOperator
{
  private String urlDb;
  
  public TwoTierOperator(String url)
  {
    urlDb=new String(url);
  }//Fine costruttore
  
  public String insertNewUser(String password,
                              String name,
                              String surname,
                              String category,
                              int age)
  {
    String login=new String();
    try
    {
      //***Inserire i dati nella tavola UTENTE REALE
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      ResultSet rs;
      //Cerchiamo un login disponibile per il nuovo utente
      do
      {
        int i=1;
        login=name+"."+surname+"."+i;
        rs=st.executeQuery("SELECT Login, Password FROM "+
                           "UtenteReale WHERE Login=\'"+
                           login+"\'");
        i++;
      }
      while (rs.next());
      //Creiamo la query per l'inserimento dei dati
      String query="INSERT INTO UtenteReale "+
                   "(Login, Password, Nome, Cognome, "+
                   "Categoria, Eta, PrimaVolta) "+
                   "VALUES (\'" +login+"\', \'"+password+
                   "\', \'"+name+"\', \'"+surname+
                   "\', \'"+category+"\', "+age+", True)";
      //Eseguiamo la query
      st.executeUpdate(query);
      con.close();
      return login;
    }
    catch (SQLException sqle)
    {
      return "";
    }
  }//Fine insertNewUser
  
  private String getAverageUser(String category, int age)
  {
    try
    {
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      //Eseguiamo la query
      ResultSet rs=st.executeQuery("SELECT Login FROM UtenteMedio "+
                                   "WHERE Categoria=\'"+category+
                                   "\' AND EtaMin<="+age+
                                   " AND EtaMax>"+age);
      //Se esiste creiamo una stringa e la restituiamo
      if (rs.next())
      {
        String averageUser=rs.getString("Login");
        con.close();
        return averageUser;
      }
      else
      {
        con.close();
        return "";
      }
    }
    catch (SQLException sqle)
    {
      return "";
    }
  }//Fine getAverageUser
  
  private void initUserInterest(String userLogin, 
                                String averageUser,
                                int argument,
                                boolean firstTime)
  {
    int iDegreeIndex;
    int moduleIndex;
    int interDegree;
    int module;
    String query;
    try
    {
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      //Creiamo un nuovo oggetto Statement
      Statement st2=con.createStatement();
      //Eseguiamo la query alla ricerca delle UDC 
      //dell'utente medio
      ResultSet rs=st.executeQuery("SELECT UDC.Modulo, UDC.GradoInteresse "+
                                   "FROM UDC, Modulo, StrutturaArgomento "+
                                   "WHERE UDC.Utente=\'"+averageUser+"\' "+
                                   "AND Modulo.ID=UDC.Modulo AND "+
                                   "Modulo.Concetto=StrutturaArgomento.Concetto "+
                                   "AND StrutturaArgomento.Argomento="+argument);
      //Se esiste inseriamo i dati nella tabella UDC
      //con il login dell'utente attuale
      if (rs.next())
      {
        iDegreeIndex=rs.findColumn("GradoInteresse");
        moduleIndex=rs.findColumn("Modulo");
        interDegree=rs.getInt(iDegreeIndex);
        module=rs.getInt(moduleIndex);
        //Creiamo la query per l'aggiornamento
        query="INSERT INTO UDC (Modulo, Utente, GradoInteresse) "+
              "VALUES ("+module+", \'"+userLogin+"\', "+
              interDegree+")";
        //Eseguiamo la query
        st2.executeUpdate(query);
        while(rs.next())
        {
          interDegree=rs.getInt(iDegreeIndex);
          module=rs.getInt(moduleIndex);
          //Creiamo la query per l'aggiornamento
          query="INSERT INTO UDC (Modulo, Utente, GradoInteresse) "+
                "VALUES ("+module+", \'"+userLogin+"\', "+
                interDegree+")";
          //Eseguiamo la query
          st2.executeUpdate(query);
        }
      }
      //Aggiorniamo la tabella ListaArgomenti
      query="INSERT INTO ListaArgomenti (Utente, Argomento) "+
            "VALUES (\'"+userLogin+"\', "+argument+")";
      st.executeUpdate(query);
      if (firstTime)
      {
        //Eseguiamo la query di ricerca del grado di interesse
        //dell'utente medio per gli information type
		  	rs=st.executeQuery("SELECT InformationType, GradoInteresse "
			                     +"FROM ReportInfType WHERE Utente=\'"
			                     +averageUser+"\'");
  			//Se esiste inseriamo i dati nella tabella ReportInfType
	  		//con il login dell'utente attuale
		  	if (rs.next())
			  {
  			  int infTypeIndex=rs.findColumn("InformationType");
	  		  iDegreeIndex=rs.findColumn("GradoInteresse");
		  	  interDegree=rs.getInt(iDegreeIndex);
			    String infType=rs.getString(infTypeIndex);
			    //Creiamo la query per l'aggiornamento
      		query="INSERT INTO ReportInfType (Utente, InformationType, GradoInteresse) "+
      		      "VALUES (\'"+userLogin+"\', \'"+infType+"\', "+interDegree+")";
		      //La eseguiamo
			    st2.executeUpdate(query);
    		  while (rs.next())
	      	{
		  	    interDegree=rs.getInt(iDegreeIndex);
			      infType=rs.getString(infTypeIndex);
			      //Creiamo la query per l'aggiornamento
    			  query="INSERT INTO ReportInfType (Utente, InformationType, GradoInteresse) "+
    			        "VALUES (\'"+userLogin+"\', \'"+infType+"\', "+interDegree+")";
    		    //La eseguiamo
	      		st2.executeUpdate(query);
		      }
			  }
        //Eseguiamo la query di ricerca del grado di interesse
        //dell'utente medio per i media
		  	rs=st.executeQuery("SELECT Media, GradoInteresse "
			                     +"FROM ReportMedia WHERE Utente=\'"
			                     +averageUser+"\'");
  			//Se esiste inseriamo i dati nella tabella ReportMedia
	  		//con il login dell'utente attuale
		  	if (rs.next())
			  {
			      int mediaIndex=rs.findColumn("Media");
			      iDegreeIndex=rs.findColumn("GradoInteresse");
  			    interDegree=rs.getInt(iDegreeIndex);
	  		    String media=rs.getString(mediaIndex);
		  	    //Creiamo la query per l'aggiornamento
    	  		query="INSERT INTO ReportMedia (Utente, Media, GradoInteresse) "+
    		  	      "VALUES (\'"+userLogin+"\', \'"+media+"\', "+interDegree+")";
		    	  //La eseguiamo
  			    st2.executeUpdate(query);
      			while (rs.next())
	      		{
			        interDegree=rs.getInt(iDegreeIndex);
			        media=rs.getString(mediaIndex);
			        //Creiamo la query per l'aggiornamento
    			    query="INSERT INTO ReportMedia (Utente, Media, GradoInteresse) "+
    			          "VALUES (\'"+userLogin+"\', \'"+media+"\', "+interDegree+")";
      		    //La eseguiamo
	      		  st2.executeUpdate(query);
		      	}
			  }
		  }
      con.close();
    }
    catch (SQLException sqle)
    {
      System.out.println(sqle.getMessage());
    }
  }//Fine initUserKnowledge
  
  public boolean getUserAt(String login, String password)
  {
		try
		{
			//Otteniamo la connessione al DB
			Connection con=DriverManager.getConnection(urlDb,"","");
			//Creaiamo un oggetto Statement
			Statement st=con.createStatement();
			//Eseguiamo la query di ricerca del record
			ResultSet rs=st.executeQuery("SELECT * FROM UtenteReale "+
			                             "WHERE Login=\'"+login+
			                             "\' AND Password=\'"+password+"\'");
			//Se esiste un utente corrispondente al login 
			if (rs.next())
			{
  	    con.close();
			  return true;
		  }
			//Altrimenti ritorniamo falso
			else
			{
				con.close();
				return false;
			}//Fine else
		}
		catch(SQLException e)
		{
		  return false;
		}
  }//Fine getUserAt
  
  public int getArgument(String doc)
  {
    String path;
    String docName;
    docName=doc.substring(doc.lastIndexOf("/")+1);
    path=doc.substring(0,doc.lastIndexOf("/")+1);
		try
		{
			//Otteniamo la connessione al DB
			Connection con=DriverManager.getConnection(urlDb,"","");
			//Creaiamo un oggetto Statement
			Statement st=con.createStatement();
			//Eseguiamo la query di ricerca del record
			ResultSet rs=st.executeQuery("SELECT StrutturaArgomento.Argomento "+
			                             "FROM Frammento, Appartiene, "+
			                             "Modulo, StrutturaArgomento "+
			                             "WHERE Frammento.Nome=\'"+docName+
			                             "\' AND Frammento.Path=\'"+path+
			                             "\' AND Appartiene.Frammento=Frammento.ID"+
			                             " AND Appartiene.Modulo=Modulo.ID"+
			                             " AND Modulo.Concetto=StrutturaArgomento.Concetto");
			//Se esiste un argomento corrispondente al documento 
			if (rs.next())
			{
			  int argument=rs.getInt("Argomento");
  	    con.close();
			  return argument;
		  }
			//Altrimenti ritorniamo una stringa vuota
			else
			{
				con.close();
				return -1;
			}//Fine else
		}
		catch(SQLException e)
		{
		  System.out.println(e.getMessage());
		  return -1;
		}
  }//Fine getArgument
  
  public boolean updateUserData(String login,
                                String password,
                                long lastSession,
                                int argument)
  {
    try
    {
      java.sql.Date dateLastSession=new java.sql.Date(lastSession);
      //***Aggiornare i dati nella tavola UTENTE REALE
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      String query="";
      //Creiamo la query per l'inserimento dei dati
      query="UPDATE UtenteReale "+
            "SET UltimaSessione=#"+dateLastSession+
            "#, ArgUltimaSessione="+argument+
            ", Password=\'"+password+"\' "+
            "WHERE Login=\'"+login+"\'";
      //Eseguiamo la query
      int updateRecord=st.executeUpdate(query);
      if (updateRecord==1)
      {
        ResultSet rs=st.executeQuery("SELECT * FROM UtenteReale "+
                                     "WHERE Login=\'"+login+"\'");
        if (rs.next())
        {
  			  boolean ft=rs.getBoolean("PrimaVolta");
	      	//se  la prima volta che 
	      	//l'utente si colleaga al sito
		  	  //si inizializza con i valori dell'utente medio associato
			  	if(ft)
				  {
				    String category=rs.getString("Categoria");
  				  int age=rs.getInt("Eta");
            //***Trovare l'utente medio 
            //***che corrisponde all'utente inserito
            String averageUser=getAverageUser(category, age);
            //***Inserire le valutazioni dell'utente medio
            //***come default per l'utente inserito
            if (averageUser.length()>0)
            {
              initUserInterest(login,averageUser,argument,true);
              query="UPDATE UtenteReale \n"+
                    "SET PrimaVolta=False WHERE Login=\'"+
                    login+"\'";
              st.executeUpdate(query);
            }
	      	}
	      	//non  la prima volta che 
	      	//l'utente si colleaga al sito
	      	else
	      	{
	      	  rs=st.executeQuery("SELECT * FROM ListaArgomenti "+
	      	                     "WHERE Utente=\'"+login+"\' AND"+
	      	                     " Argomento="+argument);
	      	  //se  la prima volta che l'utente
	      	  //ha scelto questo argomento
	      	  if (!rs.next())
	      	  {
  				    String category=rs.getString("Categoria");
    				  int age=rs.getInt("Eta");
              //***Trovare l'utente medio 
              //***che corrisponde all'utente inserito
              String averageUser=getAverageUser(category, age);
              //***Inserire le valutazioni dell'utente medio
              //***come default per l'utente inserito
              if (averageUser.length()>0)
              {
                initUserInterest(login,averageUser,argument,false);
              }
	      	  }
	      	}
	      }
        return true;
      }
      else
        return false;
    }
    catch (SQLException sqle)
    {
      System.out.println(sqle.getMessage());
      return false;
    }
  }//Fine updateUserData
  
  public boolean updateUserInterest(String login,
                                    String doc,
                                    float value)
  {
    String path;
    String docName;
    String query;
    docName=doc.substring(doc.lastIndexOf("/")+1);
    path=doc.substring(0,doc.lastIndexOf("/")+1);
    try
    {
      //***Aggiornare i dati nella tavola UDC
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
			//Creaiamo un nuovo oggetto Statement
			Statement st2=con.createStatement();
      //Cerchiamo tutti i moduli a cui il documento appartiene
      ResultSet rs=st.executeQuery("SELECT Modulo FROM "+
                                   "Frammento, Appartiene "+
                                   "WHERE Frammento.Path=\'"+
                                   path+"\' AND Frammento.Nome=\'"+
                                   docName+"\' AND "+
                                   "Appartiene.Frammento=Frammento.ID");
      while (rs.next())
      {
        int module=rs.getInt("Modulo");
        //Creiamo la query per l'inserimento dei dati
        query="UPDATE UDC SET GradoInteresse=0.35*GradoInteresse+0.65*"+
              value+" WHERE Modulo="+module+
              " AND Utente=\'"+login+"\'";
        st2.executeUpdate(query);
        float newValue=value/10;
        updatePartOf(module,newValue,login);
        updateIsA(module,newValue,login);
        //Aggiorniamo la tabella ReportInfType
        query="UPDATE ReportInfType SET GradoInteresse="+
              "1.05*GradoInteresse WHERE Utente=\'"+login+
              "\' AND InformationType="+
              "(SELECT InformationType FROM Modulo WHERE "+
              "ID="+module+")";
        st2.executeUpdate(query);
      }
      //Aggiorniamo la tabella ReportMedia 
      query="UPDATE ReportMedia SET GradoInteresse="+
            "1.05*GradoInteresse WHERE Utente=\'"+login+
            "\' AND Media="+
            "(SELECT Media FROM Frammento WHERE "+
            "Path=\'"+path+"\' AND Nome=\'"+docName+"\')";
      st2.executeUpdate(query);
      con.close();
      return true;
    }
    catch (SQLException sqle)
    {
      return false;
    }
  }//Fine updateUserInteresse
  
  private void updatePartOf(int module, float value, String login)
  {
		try
		{
			//Otteniamo la connessione al DB
			Connection con=DriverManager.getConnection(urlDb,"","");
			//Creaiamo un oggetto Statement
			Statement st=con.createStatement();
			//Creaiamo un nuovo oggetto Statement
			Statement st2=con.createStatement();
			//Eseguiamo la query di ricerca del record
			ResultSet rs=st.executeQuery("SELECT Modulo_1.ID FROM "+
			                             "Modulo AS Modulo_1 INNER JOIN "+
			                             "(Modulo INNER JOIN [PART-OF] "+
			                             "ON Modulo.Concetto=[PART-OF].ConcettoFiglio) "+
			                             "ON (Modulo.InformationType=Modulo_1.InformationType) "+
			                             "AND (Modulo_1.Concetto=[PART-OF].ConcettoPadre) "+
			                             "WHERE Modulo.ID="+module);
			while (rs.next())
			{
			  int fatherModule=rs.getInt("ID");
			  //Creiamo la query per aggiornare i valori
        String query="UPDATE UDC SET GradoInteresse=0.35*GradoInteresse+0.65*"+
                     value+" WHERE Modulo="+fatherModule+
                     " AND Utente=\'"+login+"\'";
        st2.executeUpdate(query);
        updatePartOf(fatherModule,value/10,login);
			}
			con.close();
		}
		catch (SQLException sqle)
		{}
  }//Fine updatePartOf
  
  private void updateIsA(int module, float value,String login)
  {
		try
		{
			//Otteniamo la connessione al DB
			Connection con=DriverManager.getConnection(urlDb,"","");
			//Creaiamo un oggetto Statement
			Statement st=con.createStatement();
			//Creaiamo un nuovo oggetto Statement
			Statement st2=con.createStatement();
			//Eseguiamo la query di ricerca del record
			ResultSet rs=st.executeQuery("SELECT Modulo_1.ID FROM "+
			                             "Modulo AS Modulo_1 INNER JOIN "+
			                             "(Modulo INNER JOIN [IS-A] "+
			                             "ON Modulo.Concetto=[IS-A].Concetto) "+
			                             "ON (Modulo.InformationType=Modulo_1.InformationType) "+
			                             "AND (Modulo_1.Concetto=[IS-A].ConcettoPiuAstratto) "+
                                   "WHERE Modulo.ID="+module);
			while (rs.next())
			{
			  int abstractModule=rs.getInt("ID");
			  //Creiamo la query per aggiornare i valori
        String query="UPDATE UDC SET GradoInteresse=0.35*GradoInteresse+0.65*"+
                     value+" WHERE Modulo="+abstractModule+
                     " AND Utente=\'"+login+"\'";
        st2.executeUpdate(query);
        updateIsA(abstractModule,value/10,login);
			}
			con.close();
		}
		catch (SQLException sqle)
		{}
  }//Fine updateIsA
  
  public boolean updateAverageUser(String userLogin)
  {
    String query;
    int module, media, infType;
    float interDegree;
    try
    {
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      //Creiamo due nuovi oggetti Statement
      Statement st2=con.createStatement();
      Statement st3=con.createStatement();
      //Cerchiamo l'utente 
      ResultSet rs=st.executeQuery("SELECT * FROM "+
                                   "UtenteReale WHERE "+
                                   "Login=\'"+userLogin+"\'");
      if (rs.next())
      {
        String category=rs.getString("Categoria");
        int age=rs.getInt("Eta");
        String averageUser=getAverageUser(category,age);
        //Aggiorniamo la tabella UDC dell'Utente Medio
        query="UPDATE UDC INNER JOIN UDC AS UDC1 "+
              "ON UDC.Modulo=UDC1.Modulo "+
              "SET UDC.GradoInteresse=0.8*[UDC].[GradoInteresse]+0.2*[UDC1].[GradoInteresse] "+
              "WHERE UDC.Utente=\'"+averageUser+"\' AND UDC1.Utente=\'"+userLogin+"\'";
        st2.executeUpdate(query);
        //Aggiorniamo la tabella ReportMedia
        query="UPDATE ReportMedia INNER JOIN ReportMedia AS ReportMedia1 "+
              "ON ReportMedia.Media=ReportMedia1.Media "+
              "SET ReportMedia.GradoInteresse=0.8*[ReportMedia].[GradoInteresse]+0.2*[ReportMedia1].[GradoInteresse] "+
              "WHERE ReportMedia.Utente=\'"+averageUser+"\' AND ReportMedia1.Utente=\'"+userLogin+"\'";
        st2.executeUpdate(query);
        //Aggiorniamo la tabella ReportInfType
        query="UPDATE ReportInfType INNER JOIN ReportInfType AS ReportInfType1 "+
              "ON ReportInfType.InformationType=ReportInfType1.InformationType "+
              "SET ReportInfType.GradoInteresse=0.8*[ReportInfType].[GradoInteresse]+0.2*[ReportInfType1].[GradoInteresse] "+
              "WHERE ReportInfType.Utente=\'"+averageUser+"\' AND ReportInfType1.Utente=\'"+userLogin+"\'";
        st2.executeUpdate(query);
        con.close();
        return true;
      }
      con.close();
      return false;
    }
    catch (SQLException sqle)
    {
      System.out.println(sqle.getMessage());
      return false;
    }
  }//Fine updateAverageUser
  
  public boolean updateAllUser()
  {
    try
    {
      //***Aggiornare i dati nella tavola UDC
      //Otteniamo la connessione al DB
      Connection con=DriverManager.getConnection(urlDb,"","");
      //Creiamo un oggetto Statement
      Statement st=con.createStatement();
      //Creiamo la query per l'inserimento dei dati
      String query="UPDATE UDC SET GradoInteresse="+
                   "0.9*GradoInteresse";
      st.executeUpdate(query);
      //***Aggiornare il report media e il report inf type
      query="UPDATE ReportInfType SET GradoInteresse="+
            "0.9*GradoInteresse";
      st.executeUpdate(query);
      query="UPDATE ReportMedia SET GradoInteresse="+
            "0.9*GradoInteresse";
      st.executeUpdate(query);
      con.close();
      return true;
    }
    catch (SQLException sqle)
    {
      return false;
    }
  }//Fine updateAllUDC
  
}//Fine classe TwoTierOperator

