/*
  A basic extension of the java.applet.Applet class
 */

import java.io.*;
import java.awt.*;
import java.applet.*;
import java.net.*;

public class UserInfo extends Applet
{
  //{{DECLARE_CONTROLS
	java.awt.Checkbox firstTimeCheckbox;
	java.awt.Label loginLabel;
	java.awt.TextField loginField;
	java.awt.Label surnameLabel;
	java.awt.TextField surnameField;
	java.awt.Label nameLabel;
	java.awt.TextField nameField;
	java.awt.Label ageLabel;
	java.awt.TextField ageField;
	java.awt.Choice categoryChoice;
	java.awt.Label categoryLabel;
	java.awt.Button okButton;
	java.awt.Button resetButton;
	//}}
  
  //dati dell'utente
  private String login;
  private String name;
  private String surname;
  private String category;
  private int age;
  private final String separator=" ";
  
  //parametri per configurare i socket
  private String dbHost;
  private String adminHost;
  private int dbPort;
  private int adminPort;
  private Socket proxySocket;
  private ThreeTierOperator ttoper;

  public void init()
  {
    //{{INIT_CONTROLS
		setLayout(null);
		setSize(500,400);
		firstTimeCheckbox = new java.awt.Checkbox("E' la prima volta che si collega?");
		firstTimeCheckbox.setBounds(148,32,204,25);
		add(firstTimeCheckbox);
		loginLabel = new java.awt.Label("Login:",Label.RIGHT);
		loginLabel.setBounds(98,80,54,25);
		add(loginLabel);
		loginField = new java.awt.TextField();
		loginField.setBounds(178,80,230,25);
		add(loginField);
		surnameLabel = new java.awt.Label("Cognome:",Label.RIGHT);
		surnameLabel.setBounds(92,125,60,24);
		add(surnameLabel);
		surnameField = new java.awt.TextField();
		surnameField.setBounds(178,125,230,25);
		add(surnameField);
		nameLabel = new java.awt.Label("Nome:",Label.RIGHT);
		nameLabel.setBounds(106,170,46,24);
		add(nameLabel);
		nameField = new java.awt.TextField();
		nameField.setBounds(178,170,230,25);
		add(nameField);
		ageLabel = new java.awt.Label("Et:",Label.RIGHT);
		ageLabel.setBounds(213,215,46,24);
		add(ageLabel);
		ageField = new java.awt.TextField();
		ageField.setBounds(285,215,36,25);
		add(ageField);
		categoryChoice = new java.awt.Choice();
		categoryChoice.addItem("Programmatore esperto");
		categoryChoice.addItem("Programmatore inesperto");
		categoryChoice.addItem("Studente");
		try {
			categoryChoice.select(0);
		}
		catch (IllegalArgumentException e) { }
		add(categoryChoice);
		categoryChoice.setBounds(180,252,230,25);
		categoryLabel = new java.awt.Label("Categoria:",Label.RIGHT);
		categoryLabel.setBounds(92,252,60,24);
		add(categoryLabel);
		okButton = new java.awt.Button();
		okButton.setLabel("OK");
		okButton.setBounds(144,300,62,37);
		okButton.setBackground(new Color(12632256));
		add(okButton);
		resetButton = new java.awt.Button();
		resetButton.setLabel("Reset");
		resetButton.setBounds(300,300,61,38);
		resetButton.setBackground(new Color(12632256));
		add(resetButton);
		//}}
  
    //{{REGISTER_LISTENERS
    SymMouse aSymMouse = new SymMouse();
    okButton.addMouseListener(aSymMouse);
    resetButton.addMouseListener(aSymMouse);
    SymKey aSymKey = new SymKey();
    okButton.addKeyListener(aSymKey);
    resetButton.addKeyListener(aSymKey);
    this.addKeyListener(aSymKey);
		SymItem lSymItem = new SymItem();
		firstTimeCheckbox.addItemListener(lSymItem);
    //}}
    
    login=new String();
    name=new String();
    surname=new String();
    category=new String();
    age=0;
    initControls();
  }//Fine init
  
  private void initControls()
  {
		nameLabel.setVisible(false);
		nameField.setVisible(false);
		nameField.setEnabled(false);
		surnameLabel.setVisible(false);
		surnameField.setVisible(false);
		surnameField.setEnabled(false);
		ageLabel.setVisible(false);
		ageField.setVisible(false);
		ageField.setEnabled(false);
		categoryChoice.setVisible(false);
		categoryChoice.setEnabled(false);
		categoryLabel.setVisible(false);
  }//Fine initControls
  
  public void start()
  {
    super.start();
    //si prelevano i parametri
    dbHost=getParameter("dbHost");
    adminHost=getParameter("adminHost");
    dbPort=Integer.parseInt(getParameter("dbPort"));
    adminPort=Integer.parseInt(getParameter("adminPort"));
    ttoper=new ThreeTierOperator(dbHost,dbPort);
  }//Fine start
  
  class SymMouse extends java.awt.event.MouseAdapter
  {
    public void mouseClicked(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == okButton)
        okButton_MouseClicked(event);
      else if (object == resetButton)
        resetButton_MouseClicked(event);
    }
  }

  void okButton_MouseClicked(java.awt.event.MouseEvent event)
  {

  	Container theFrame = this;
    do
    {
      theFrame = theFrame.getParent();
    }
    while ((theFrame != null) && !(theFrame instanceof Frame));
    if (theFrame == null)
      theFrame = new Frame();
    
    ErrorDialog errDial;
    int result=getUserInfo();
    switch (result)
    {
      //tutto OK! Utente nel DB
      case 1:
        errDial=new ErrorDialog((Frame)theFrame,
                                "OK Dialog",
                                "Utente inserito con il login "+login,
                                true);
        errDial.show();
        stop();
        break;
      //login errato
      case 0:
        //visualizzare messaggio di errore
        errDial=new ErrorDialog((Frame)theFrame,
                                "Error Dialog",
                                "Login errato!",
                                true);
        errDial.show();
        break;
      //errore nella trasmissione dei dati al DB Utenti
      case -1:
        //visualizzare messaggio di errore
        errDial=new ErrorDialog((Frame)theFrame,
                                "Error Dialog",
                                "Errore nell'inserimento dati nel DB!",
                                true);
        errDial.show();
        break;
      //errore nella trasmissione dei dati al proxy
      case -2:
        //visualizzare messaggio di errore
        errDial=new ErrorDialog((Frame)theFrame,
                                "Error Dialog",
                                "Errore nella trasmisione dati!",
                                true);
        errDial.show();
        break;
    }
  }//Fine okButton_MouseClicked
  
  void resetButton_MouseClicked(java.awt.event.MouseEvent event)
  {
    resetComponent();
  }//Fine resetButton_MouseClicked


  class SymKey extends java.awt.event.KeyAdapter
  {
    public void keyPressed(java.awt.event.KeyEvent event)
    {
      Object object = event.getSource();
      if (object == okButton)
        okButton_KeyPressed(event);
      else if (object == resetButton)
        resetButton_KeyPressed(event);
    }
  }

  void okButton_KeyPressed(java.awt.event.KeyEvent event)
  {

  	Container theFrame = this;
    do
    {
      theFrame = theFrame.getParent();
    }
    while ((theFrame != null) && !(theFrame instanceof Frame));
    if (theFrame == null)
      theFrame = new Frame();
    
    ErrorDialog errDial;
    if (event.getKeyChar()=='\n')
    {
      int result=getUserInfo();
      switch (result)
      {
        //tutto OK! Utente nel DB
        case 1:
          errDial=new ErrorDialog((Frame)theFrame,
                                  "OK Dialog",
                                  "Utente inserito con il login "+login,
                                  true);
          errDial.show();
          stop();
          break;
        //login errato
        case 0:
          //visualizzare messaggio di errore
          errDial=new ErrorDialog((Frame)theFrame,
                                  "Error Dialog",
                                  "Login errato!",
                                  true);
          errDial.show();
          break;
        //errore nella trasmissione dei dati al DB Utenti
        case -1:
          //visualizzare messaggio di errore
          errDial=new ErrorDialog((Frame)theFrame,
                                  "Error Dialog",
                                  "Errore nell'inserimento dati nel DB!",
                                  true);
          errDial.show();
          break;
        //errore nella trasmissione dei dati al proxy
        case -2:
          //visualizzare messaggio di errore
          errDial=new ErrorDialog((Frame)theFrame,
                                  "Error Dialog",
                                  "Errore nella trasmisione dati!",
                                  true);
          errDial.show();
          break;
      }
    }
    else if (event.getKeyCode()==event.VK_RIGHT)
      resetButton.requestFocus();
  }// Fine okButton_KeyPressed

  void resetButton_KeyPressed(java.awt.event.KeyEvent event)
  {
    if (event.getKeyChar()=='\n')
    {
      resetComponent();
    }
    else if (event.getKeyCode()==event.VK_LEFT)
      okButton.requestFocus();
  }
  
  public void stop()
  {
    super.stop();
    firstTimeCheckbox.setEnabled(false);
    firstTimeCheckbox.setVisible(false);
    loginField.setEnabled(false);
    loginField.setVisible(false);
    loginLabel.setVisible(false);
    nameField.setEnabled(false);
    nameField.setVisible(false);
    nameLabel.setVisible(false);
    surnameField.setEnabled(false);
    surnameField.setVisible(false);
    surnameLabel.setVisible(false);
    ageLabel.setVisible(false);
    ageField.setVisible(false);
    ageField.setEnabled(false);
    categoryLabel.setVisible(false);
    categoryChoice.setEnabled(false);
    categoryChoice.setVisible(false);
    try
    {
      proxySocket.close();
    }
    catch (IOException ioe)
    {}
  }//Fine stop
  

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == firstTimeCheckbox)
				firstTimeCheckbox_ItemStateChanged(event);
		}
	}

	void firstTimeCheckbox_ItemStateChanged(java.awt.event.ItemEvent event)
	{
	  loginLabel.setVisible(!firstTimeCheckbox.getState());
	  loginField.setEnabled(!firstTimeCheckbox.getState());
	  loginField.setVisible(!firstTimeCheckbox.getState());
		nameLabel.setVisible(firstTimeCheckbox.getState());
		surnameLabel.setVisible(firstTimeCheckbox.getState());
		nameField.setEnabled(firstTimeCheckbox.getState());
		surnameField.setEnabled(firstTimeCheckbox.getState());
		nameField.setVisible(firstTimeCheckbox.getState());
		surnameField.setVisible(firstTimeCheckbox.getState());
		ageLabel.setVisible(firstTimeCheckbox.getState());
		ageField.setVisible(firstTimeCheckbox.getState());
		ageField.setEnabled(firstTimeCheckbox.getState());
		categoryLabel.setVisible(firstTimeCheckbox.getState());
		categoryChoice.setVisible(firstTimeCheckbox.getState());
		categoryChoice.setEnabled(firstTimeCheckbox.getState());
		if (!firstTimeCheckbox.getState())
		{
		  resetComponent();
		}
	}//Fine firstTimeCheckbox_ItemStateChanged
	
	private void resetComponent()
	{
	  loginField.setText("");
	  nameField.setText("");
	  surnameField.setText("");
	  ageField.setText("");
	  categoryChoice.select(0);
	}//Fine resetComponent
	
	//ritorna 1 se va tutto bene
	//ritorna 0 se c' un errore nel login
	//ritorna -1 se c' un errore di trasmissione con il DB Utenti
	//ritorna -2 se c' un errore di trasmissione con il proxy
	private int getUserInfo()
	{
	  boolean firstTime=firstTimeCheckbox.getState();
	  int result=1;
	  String buffer=new String();
	  //si prelevano i dati immessi dall'utente
  	if (firstTime)
	  {
	    name=nameField.getText();
	    surname=surnameField.getText();
  	  category=categoryChoice.getSelectedItem();
	    age=Integer.parseInt(ageField.getText());
	  }
  	else
	    login=loginField.getText();
	  //controllare nel DB se i dati vanno bene
	  if (firstTime)
	  {
	    login=ttoper.insertNewUser("",name,surname,category,age);
	    //problemi nell'inserimento dell'utente nel DB
	    if (login.equals("NULL"))
	      return -1;
	    else
	      result=1;
	  }
	  else
	  {
	    if (ttoper.getUserAt(login,""))
	      result=1;
	    else
	      //login errato
	      return 0;
	  }
	  //inserimento dati nel config
	  try
	  {
	    //si apre il socket con il proxy
  	  proxySocket=new Socket(adminHost,adminPort);
      DataOutputStream out=new DataOutputStream(proxySocket.getOutputStream());
      BufferedReader in=new BufferedReader(new InputStreamReader(proxySocket.getInputStream()));
      out.writeBytes("USERINFO\n");
      out.flush();
	    if (in.readLine().equals("ACCEPT"))
  	  {
  	    buffer=dbHost+"\n";
  	    out.writeBytes(buffer);
  	    out.flush();
	      buffer=login+separator;
	      buffer+="NULL"+separator;
	      buffer+="\n";
	      out.writeBytes(buffer);
	      out.flush();
	      if(in.readLine().equals("INSERTOK"))
	        result=1;
	      else
	      {
	        //in.readLine().equals("ERROR")
	        return -2;
	      }
	    }
	    return result;
	  }
	  catch (Exception e)
	  {
	    return -2;
	  }
	  
	}//Fine getUserInfo
	
}// Fine classe UserInfo
